<script>
	import SVG from "@/components/svg.svelte"
	import FilterItem from "@/components/Filter/Item.svelte"
	import PriceRange from "@/components/Filter/PriceRange.svelte"
	import TypesSelector from "@/components/Filter/TypesSelector.svelte"
	import BrandsSelector from "@/components/Filter/BrandsSelector.svelte"

	import { isLight } from "@/stores/static"
	import { active } from "@/stores/filter"
	import { t, l } from "@/i18n"
	import { isPhone } from "@/stores/responsiveness"
	import { afterNavigate, goto } from "$app/navigation"
	import { page } from "$app/stores"
	import { writable } from "svelte/store"

	import debounce from "@/helpers/debounce"
	import query from "@/helpers/query"
	import { onMount } from "svelte"

	let typesChecked = writable({})
	let brandsChecked = writable({})
	let price = writable({ from: "", to: "" })

	$: hasFilter = (() => {
		const hasTypes = $page.url.searchParams.has("types")
		const hasBrands = $page.url.searchParams.has("brands")
		const hasPrice = $page.url.searchParams.has("price_min") || $page.url.searchParams.has("price_max")

		return hasTypes || hasBrands || hasPrice || $page.params.slug
	})();

	const clearFilter = () => goto($l("cars"), { noScroll: true })
	const clearPrice = () => price.set({ from: "", to: "" })
	const setPrice = () => {
		$price.from = $page.url.searchParams.get("price_min") || ""
		$price.to = $page.url.searchParams.get("price_max") || ""
	}

	const parseList = obj => {
		const selected = Object.keys(obj).filter(prop => !!obj[prop])

		const r = selected.join(",")

		return { r, c: selected.length }
	}

	const hasNewParams = newParams => {
		newParams = new URLSearchParams(newParams)
		const { searchParams: oldParams } = $page.url

		let has = false
		
		return (
			oldParams.get("types") !== newParams.get("types")
			|| oldParams.get("brands") !== newParams.get("brands")
			|| oldParams.get("price_min") !== newParams.get("price_min")
			|| oldParams.get("price_max") !== newParams.get("price_max")
		)
	}

	typesChecked.subscribe(debounce(handleChange, 150))
	brandsChecked.subscribe(debounce(handleChange, 150))
	price.subscribe(debounce(handleChange, 500))

	function handleChange() {
		if (!import.meta.env.SSR) {
			const queryParams = {}
			const slug = $page.params.slug

			if ($page.url.searchParams.get("popular"))
				queryParams.popular = "ASC"

			const { r: typesString, c: typesCount } = parseList($typesChecked)
			const { r: brandsString, c: brandsCount } = parseList($brandsChecked)

			const onlyType = typesCount == 1 && (!brandsCount || brandsCount > 1)
			const onlyBrand = brandsCount == 1 && (!typesCount || typesCount > 1)

			let queryString = ""
			
			if ($price.from || $price.to) {
				if ($price.from)
					queryParams.price_min = $price.from
				if ($price.to)
					queryParams.price_max = $price.to
			}

			const hasSlug = (onlyType && !brandsCount) || (onlyBrand && !typesCount)
			if (hasSlug) {
				let targetSlug = onlyType ? typesString : brandsString
				
				if ((($l(`cars/${targetSlug}`) !== $page.url.pathname || query(queryParams) !== $page.url.search) && hasNewParams(query(queryParams))) || !slug)
					goto($l(`cars/${targetSlug}`) + query(queryParams), { noScroll: true, keepFocus: true })
			} else {
				if (typesString)
					queryParams.types = typesString

				if (brandsString)
					queryParams.brands = brandsString
				
				if (hasNewParams(query(queryParams)) || !!slug)
					goto($l(`cars`) + query(queryParams), { noScroll: true, keepFocus: true })
			}
		}
	}

	onMount(setPrice)
	afterNavigate(setPrice)
</script>

<template lang="pug">
	.filter.is-flex.is-flex-direction-column.is-align-items-flex-start.is-justify-content-flex-start( class:dark='{!$isLight}' )
		+if('$isPhone')
			.top.is-flex.is-align-items-center.is-justify-content-space-between
				.back.is-flex.is-align-items-center( on:click!='{() => active.set(false)}' )
					span.icon.is-flex: SVG( folder="icons" name="angle-left" )
					|{$t("buttons.filter")}
				+if('hasFilter')
					.clear( on:click!='{clearFilter}' ) {$t("buttons.clear_all")}
		FilterItem( title!='{$t("heading.price")}, USD' )
			PriceRange( bind:from='{$price.from}' bind:to='{$price.to}' on:clear!='{clearPrice}' )
		FilterItem( title!='{$t("heading.class")}' )
			TypesSelector( bind:value='{$typesChecked}' )
		FilterItem( title!='{$t("heading.make")}' )
			BrandsSelector( bind:value='{$brandsChecked}' )
</template>

<style lang="scss">
	.top {
		width: 100%;
		margin-bottom: 1.5rem;
		.back {
			font-size: .875rem;
			font-weight: 500;
			text-transform: uppercase;
			color: $blue-link;
			.icon {
				width: 1rem;
				margin-right: .5rem;
				:global(svg) {
					height: 1rem;
				}
				:global(svg path) {
					fill: $blue-link;
				}
			}
		}
		.clear {
			font-size: .875rem;
			font-weight: 300;
			text-align: center;
			color: $red;
			padding: .5rem;
			border: 1px solid $red;
		}
	}

	.filter {
		padding-right: 1px;
		background: $white;
		overflow-y: auto;
		transition: 
			background .2s ease-in-out,
			scrollbar-color .2s ease-in-out;
		&.dark {
			background: #1E1E1E;
			:global(.list-item) {
				&:hover {
					background: #2E2E2E;
				}
			}
		}
		@include min_mobile {
			max-height: calc(100vh - 7.5rem);
			position: sticky;
			top: 7.5rem;
		}
		@include max_mobile {
			max-width: 270px;
			height: 100vh;
			padding: 1rem 2rem 1rem 1.5rem;
			position: relative;
			z-index: 2;
		}
	}

	.filter :global(.field+.list) {
		margin-top: 2rem;
	}

	.filter,
	.filter :global(.list) {
		scrollbar-color: $gray-dark transparent;
		scrollbar-width: thin;

		&::-webkit-scrollbar {
			width: 4px;
		}

		&::-webkit-scrollbar-track {
			background: $gray;
			border-radius: 24px;
			transition: background .2s ease-in-out;
		}

		&::-webkit-scrollbar-thumb {
			background: $gray-dark;
			border-radius: 24px;
			cursor: pointer;
			transition: background .2s ease-in-out;
		}

		&::-webkit-scrollbar-thumb:hover {
			background: $gray-dark;
		}
	}

	.filter.dark,
	.filter.dark :global(.list) {
		scrollbar-color: #434343 #2E2E2E;

		&::-webkit-scrollbar-track {
			background: #2E2E2E;
		}

		&::-webkit-scrollbar-thumb {
			background: #434343;
		}

		&::-webkit-scrollbar-thumb:hover {
			background: #434343;
		}
	}

	.filter :global(.list) {
		max-height: 440px;
		overflow-x: hidden;
		overflow-y: auto;
	}

	.filter :global(.list-item) {
		transition: background .2s ease-in-out;
		&:hover {
			background: $gray;
		}
	}

	.filter :global(.list-item .checkbox) {
		width: 100%;
		padding: .5rem .125rem;
	}
</style>